/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.wahlbeteiligung.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertung;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractWahlbeteiligungAuswertungSearch {

  @Inject
  protected transient WahlbeteiligungAuswertungExtendedDAO dao;

  public AbstractWahlbeteiligungAuswertungSearch() {
    super();
  }

  public List<WahlbeteiligungAuswertung> getSearchResult(WahlbeteiligungAuswertungSearchParameters searchParameters, EagerLoadingCollector<WahlbeteiligungAuswertung> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<WahlbeteiligungAuswertung> querySearchResult(WahlbeteiligungAuswertungSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
